//+------------------------------------------------------------------+
//|                                                  MFIWithFlat.mq5 |
//|                                 Copyright  2014, Powered byStep | 
//|                                                                  | 
//+------------------------------------------------------------------+
#property description "Money Flow Index With Flat"
//----  
#property copyright "Copyright  2014, Powered byStep"
//----  
#property link      ""
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----        
#property indicator_buffers 3
//----    
#property indicator_plots   2
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//---      
#property indicator_type1   DRAW_FILLING
//---     
#property indicator_color1  clrDodgerBlue,clrMagenta
//----    
#property indicator_label1  "MFI Oscillator"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_LINE
//----         
#property indicator_color2  clrLightSlateGray
//----   2 -  
#property indicator_style2  STYLE_SOLID
//----    2  5
#property indicator_width2  5
//----    
#property indicator_label2  "Flat"
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1 70.0
#property indicator_level2 50.0
#property indicator_level3 30.0
#property indicator_levelcolor clrGray
#property indicator_levelstyle STYLE_DASHDOTDOT
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint                BBPeriod=20;                 //    
input double              StdDeviation=2.0;            //  
input ENUM_APPLIED_PRICE  applied_price=PRICE_CLOSE;   //   
input uint                MFIPeriod=14;                //  MFI
input ENUM_APPLIED_VOLUME VolumeType=VOLUME_TICK;      // 
input uint                MAPeriod=13;                 //    
input  ENUM_MA_METHOD     MAType=MODE_SMA;             //    
input uint                flat=100;                    //    
input int                 Shift=0;                     //       
//+----------------------------------------------+
//----   ,    
//      
double IndBuffer[];
double SignalBuffer[];
double IndBuffer1[];
//----      
int BB_Handle,MFI_Handle,MA_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
int OnInit()
  {
//----     
   min_rates_total=int(MathMax(BBPeriod,MFIPeriod));

//----    iBands
   BB_Handle=iBands(Symbol(),PERIOD_CURRENT,BBPeriod,0,StdDeviation,applied_price);
   if(BB_Handle==INVALID_HANDLE)
     {
      Print("      iBands");
      return(INIT_FAILED);
     }
//----    iMFI
   MFI_Handle=iMFI(Symbol(),PERIOD_CURRENT,MFIPeriod,VolumeType);
   if(MFI_Handle==INVALID_HANDLE)
     {
      Print("      iMFI");
      return(INIT_FAILED);
     }
//----    iMA
   MA_Handle=iMA(Symbol(),PERIOD_CURRENT,MAPeriod,0,MAType,MFI_Handle);
   if(MA_Handle==INVALID_HANDLE)
     {
      Print("      iMA");
      return(INIT_FAILED);
     }

//----      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----       
   ArraySetAsSeries(IndBuffer,true);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----      
   SetIndexBuffer(1,SignalBuffer,INDICATOR_DATA);
//----       
   ArraySetAsSeries(SignalBuffer,true);

//----      
   SetIndexBuffer(2,IndBuffer1,INDICATOR_DATA);
//----       
   ArraySetAsSeries(IndBuffer1,true);
//----    1    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   IndicatorSetString(INDICATOR_SHORTNAME,"MFIWithFlat");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(BarsCalculated(BB_Handle)<rates_total
      || BarsCalculated(MFI_Handle)<rates_total
      || BarsCalculated(MA_Handle)<rates_total
      || rates_total<min_rates_total) return(RESET);

//----    
   int to_copy,limit,bar;
   double MainMFI[],SignMFI[],UpBB[],MainBB[];

//----         limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_total-1; //      
     }
   else limit=rates_total-prev_calculated; //      
   to_copy=limit+1;

//----      
   if(CopyBuffer(BB_Handle,UPPER_BAND,0,to_copy,UpBB)<=0) return(RESET);
   if(CopyBuffer(BB_Handle,BASE_LINE,0,to_copy,MainBB)<=0) return(RESET);
   if(CopyBuffer(MFI_Handle,MAIN_LINE,0,to_copy,MainMFI)<=0) return(RESET);
   if(CopyBuffer(MA_Handle,MAIN_LINE,0,to_copy,SignMFI)<=0) return(RESET);

//----         
   ArraySetAsSeries(UpBB,true);
   ArraySetAsSeries(MainBB,true);
   ArraySetAsSeries(MainMFI,true);
   ArraySetAsSeries(SignMFI,true);

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      double res=(UpBB[bar]-MainBB[bar])/_Point;
      if(res<flat)
        {
         if(MainMFI[bar]>SignMFI[bar])
           {
            IndBuffer[bar]=50;
            SignalBuffer[bar]=50;
            IndBuffer1[bar]=50;
           }

         if(MainMFI[bar]<SignMFI[bar])
           {
            IndBuffer[bar]=50;
            SignalBuffer[bar]=50;
            IndBuffer1[bar]=50;
           }
        }
      else
        {
         IndBuffer1[bar]=EMPTY_VALUE;
         IndBuffer[bar]=MainMFI[bar];
         SignalBuffer[bar]=SignMFI[bar];
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
